/*
 * Misc.java
 *
 * Created on 10. marraskuuta 2004, 17:22
 */

package graphlib;

import java.util.*;

/**
 *
 * @author  millat
 */
public class Misc {
    //   HashMap c = null; //joku muu ratkasu jrkevmpi, tehty nyt vain "helposti"
    //   HashMap nc = null;
    int[] zeroList = null;
    double[] a = null;
    private static double EPSILON = 0.0000000001;
    private static int AZERO = 1;
    private static int FZERO = 2;
    
    /** Creates a new instance of Misc */
    public Misc() {
    }
    
    //palauttaa s:n ja j:n taulukossa.. j on int ja turhaan muunnetaan nyt doubleksi..
    private Vector maxStep(double[] f, double[] df, double[] da, int d) {
        double s = 1000000000000000000000000000000000000000000000000.0;
        int j = -1;
        //    System.out.println("da[d]: "+da[d]);
        if(da[d] > EPSILON) { //>0
            j = d;
            s = -1*a[d]/da[d];
        }
        /*
        for(int i = 0; i<c.size(); i++) {
            if(i<d) { //Viren koodista
                if(df[i] < 0 ) { //<-EPSILON
                    double sd = -1*f[i]/df[i];
                    if(sd<s) {
                        s = sd;
                        j = i;
                    }
                }
            }
        }
         
        for(int i = 0; i<nc.size(); i++) {
            if(i<d) { //Viren koodista
                if(da[i]< 0) { //<-EPSILON
                    double sd = -1*a[i]/da[i];
                    if(sd<s) {
                        s = sd;
                        j = i;
                    }
                }
            }
        }*/
        
        for (int i = 0; i < d; i++) {
            if (zeroList[i] == AZERO) {
                if (df[i] < 0 /* -EPSILON */) {
                    double sd = -1*f[i]/df[i];
                    if(sd<s) {
                        s = sd;
                        j = i;
                    }
                }
            } else {
                if(da[i]< 0) { //<-EPSILON
                    double sd = -1*a[i]/da[i];
                    if(sd<s) {
                        s = sd;
                        j = i;
                    }
                }
            }
        }
        //  System.out.println("j: "+j+" s: "+s);
        Vector sj = new Vector(2);
        sj.add(0,new Integer(j));
        sj.add(1, new Double(s));
        return sj;
        
    }
    
    private double[] Cholesky(double[][] a11, double[] v) {
        double[] x =  MatrixCalculations.initVector(v.length);
        double[] y =  MatrixCalculations.initVector(v.length);
        double[][] lMat = MatrixCalculations.initMatrix(a11.length, a11[0].length);
        for(int i=0; i<lMat.length; i++) {
            for(int j=0; j<=i; j++) {
                if(i==j) {
                    double sum = 0.0;
                    for(int k=0; k<i-1; k++) {
                        sum += Math.pow(lMat[i][k], 2.0);
                        
                        lMat[i][j] = Math.pow(a11[i][j]-sum, 1.0/2);
                    }
                } else {
                    double sum = 0.0;
                    for(int k=0; k<j-1; k++) {
                        sum += lMat[i][k]*lMat[j][k];
                    }
                    if(lMat[j][j] == 0)
                        System.out.println("Nollalla jako");
                    lMat[i][j] = (1.0/lMat[j][j])*(a11[i][j]-sum);
                }
            }
        }
        
        for(int i=0; i<y.length; i++) {
            double sum = 0;
            for(int k=0; k<i-1; k++) { 
                sum += lMat[i][k]*y[k];
            }
            y[i] = lMat[i][i]*(v[i]-sum);
        }
        
        for(int i=x.length-1; i>=0; i--) {
            double sum = 0;
            //   System.out.println("i: "+i);
            for(int k=i+1; k<x.length; k++) {
                //       System.out.println("j: "+j);
                sum += lMat[k][i]*x[k];
            }
            //   System.out.println("uMat: "+uMat[i][i]);
            if(lMat[i][i] == 0.0) {
                System.out.println("Jaetaan nollalla");
            }
            x[i] = (1.0/lMat[i][i])*(y[i]-sum);
        }
        return x;
    }
    
    private double[] LU(double[][] a11, double[] v) {
        double[] x =  MatrixCalculations.initVector(v.length);
        double[] y =  MatrixCalculations.initVector(v.length);
        //     System.out.println("A11:n koko: "+a11.length+" "+a11[0].length);
        //     System.out.println("v:n koko: "+ v.length);
        //jos a on m*n matriisi, niin l on m*m ja u m*n, oletetaan, ett a on m*m matriiisi..
        double[][] lMat = MatrixCalculations.initMatrix(a11.length, a11[0].length);
        double[][] uMat = MatrixCalculations.initMatrix(a11.length, a11[0].length);
        for(int i=0; i<lMat.length; i++) {
            for(int j=0; j<lMat[i].length; j++) {
                if(j<i) {
                    double sum = 0;
                    for(int k=0; k<j-1; k++) { 
                        sum += lMat[i][k]*uMat[k][j];
                    }
                    if(uMat[j][j] == 0.0) {
                        System.out.println("Jaetaan nollalla");
                    }
                    lMat[i][j] = (1.0/uMat[j][j])*(a11[i][j] - sum);
                } else {
                    if(j==i)
                        lMat[i][j] = 1.0;
                    double sum = 0;
                    for(int k=0; k<i-1; k++) {
                        sum += lMat[i][k]*uMat[k][j];
                    }
                    uMat[i][j] = a11[i][j] - sum;
                }
            }
        }
        //   MatrixCalculations.printMatrix(uMat);
        //   MatrixCalculations.printMatrix(lMat);
        for(int i=0; i<y.length; i++) {
            double sum = 0;
            for(int j=0; j<i-1; j++) { 
                sum += lMat[i][j]*y[j];
            }
            y[i] = v[i]-sum;
        }
        // MatrixCalculations.printVector(y);
        for(int i=x.length-1; i>=0; i--) {
            double sum = 0;
            //   System.out.println("i: "+i);
            for(int j=i+1; j<x.length; j++) {
                //       System.out.println("j: "+j);
                sum += uMat[i][j]*x[j];
            }
            //   System.out.println("uMat: "+uMat[i][i]);
            if(uMat[i][i] == 0.0) {
                System.out.println("Jaetaan nollalla");
            }
            x[i] = (1.0/uMat[i][i])*(y[i]-sum);
        }
        
        return x;
    }
    
    private double[] fDirection(int d, int length, double[][] aMat) {
        double df[] = MatrixCalculations.initVector(length); //work_F
        df[d] = 1;
        int size = 0;
        for(int i=0; i<zeroList.length; i++) {
            if(zeroList[i]== FZERO ) {
                size ++;
            }
        }
        // if(c.size() > 0) {
        if(size < aMat.length) {
            int row = 0;
            int column = 0;
            //  int size = c.size();
    /*        if(c.containsKey(new Integer(-1)))
                size--;*/
            double[][] a11 = new double[aMat.length-size][aMat[0].length-size];
      /*      Set keyS = c.keySet();
            Iterator keyI = keyS.iterator();
       
            while(keyI.hasNext()) {
                Integer keyInt = (Integer)keyI.next();
                int ind = keyInt.intValue();
       
        }
       */
            //A11 = Acc (jos C on tyhj, niin mit j sillon A11:een!!!!! Vai skipataanko tm tultaessa ekaa kertaa..??
            //A11 on A matriisista jljell oleva osa, kun siit on poistettu kaikki rivit ja sarakkeet, joiden indeksi on C:ss
            
            for(int i=0; i<aMat.length; i++) {
                //if(c.containsKey(new Integer(i))) {
                if(zeroList[i] == FZERO) {
                    continue;
                }
                column = 0;
                for(int j=0; j<aMat[i].length; j++) {
                    //  if(c.containsKey(new Integer(j))) {
                    if(zeroList[j] == FZERO) {
                        continue;
                    }
                    a11[row][column] = aMat[i][j];
                    column++;
                }
                row++;
            }
            //v1 = Acd, A:sta d:s sarake ja siit pois kaikki ne alkiot, joiden indeksi on C:ss
            double[] v1 = new double[aMat[0].length-size];
            int index = 0;
            for(int i=0; i<aMat.length; i++) {
                for(int j=0; j<aMat[i].length; j++) {
                    if(j == d) {
                        // if(c.containsKey(new Integer(i))) {
                        // System.out.println("zeroList: "+zeroList[j]);
                        if(zeroList[i] == FZERO) {
                            continue;
                        }
                        v1[index] = aMat[i][j];
                        index++;
                    }
                }
            }
            
            //ratkaise A11x=-v1 LU-hajotelm
            
            double[] x = LU(a11, MatrixCalculations.multiplyVectorByX(v1, -1.0));
           // double[] x = Cholesky(a11, MatrixCalculations.multiplyVectorByX(v1, -1.0));
            //muuta x df:ksi
           /* Set keySet = c.keySet();
            Iterator keyIter = keySet.iterator();
            
            while(keyIter.hasNext()) {
                Integer key = (Integer)keyIter.next();
                index = key.intValue();
                if(index < d)  //ehto Vireen koodista..
                  df[index] = x[index];
            }*/
            int counter = 0;
            for (int i = 0; i < d; i++) {
                if (zeroList[i] == AZERO) {
                    df[i] = x[counter]; //oliko tm vanhoissa vrin??
                    counter++;
                }
            }
            
      /*  Integer[] keys = (Integer[])keySet.toArray();
        for(int i=0; i< keys.length; i++) {
            Integer key = keys[i];
            index = key.intValue();
            df[index] = x[index];
       
        }*/
        }
        return df;
    }
    
    private double[] driveToZero(int d, double[][] aMat, double[] f) throws MatrixException {
        while(true) { //ehto?? Koko rakenne fiksumpi muulla tavalla..?
            double[] df = fDirection(d, f.length, aMat);
            double[] da = MatrixCalculations.multiplyMatrixByVector(aMat, df);
            // Integer J = new Integer(0);
            // Double S = new Double(0.0);
            Vector sj = maxStep(f, df, da, d);
            Integer J = (Integer)sj.get(0);
            int j = J.intValue();
            Double S = (Double)sj.get(1);
            
            f = MatrixCalculations.sumVectors(f,  MatrixCalculations.multiplyVectorByX(df, S.doubleValue()));
            
            //     System.out.println(S.doubleValue()+" "+J.intValue());
            a = MatrixCalculations.sumVectors(a,  MatrixCalculations.multiplyVectorByX(da, S.doubleValue()));
            
            /*if(c.containsKey(J)) {
                c.remove(J);
                nc.put(J, null);
            } else if(nc.containsKey(J)) {
                nc.remove(J);
                c.put(J, null);
                System.out.println("Laitetaan c:hen : " +J.intValue());
            } else {
                c.put(J, null);
                System.out.println("Laitetaan c:hen : " +J.intValue());
                return f;
            }*/
            if (zeroList[j] == FZERO)
                zeroList[j] = AZERO;
            else if (zeroList[j] == AZERO)
                zeroList[j] = FZERO;
            else {
                zeroList[j] = AZERO;
                return f;
            }
        }
    }
    
    //Ratkaistaan f kyttmll Dantzigin algoritmia
    public double[] solveF(double[][] aMat, double[] b) throws MatrixException {
        double[] f = MatrixCalculations.initVector(b.length);
        // this.a = b;
        a = new double[b.length];
        zeroList = new int[b.length];
        for(int i=0; i<b.length; i++) {
            a[i] = b[i];
            zeroList[i] = 0;
        }
        // this.c= new HashMap(); //ZERO_ACC
        //  this.nc= new HashMap(); //ZERO_FORCE;
        
        for(int i=0; i<a.length; i++) {
            if(a[i] >= 0) {
                //nc.put(new Integer(i), null);
                zeroList[i] = FZERO;
            }
            //if(a[i]<0) {
            else{
                f = driveToZero(i, aMat, f); //kyllp pit vied parametreja...
                //  i=0;
            }
        }
        
        return f;
    }
    
}
