package graphlib;
import java.util.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class RungeKuttaSolver extends DESolver {

    public RungeKuttaSolver(Derivable d) {
        super(d);
    }


    public double[] calculate(double t, double h, double[] x) throws MatrixException {
        double th = t + (h/2.0);
        double[] k1 = MatrixCalculations.multiplyVectorByX(d.dydt(x,t),h);
        double[] k2 = MatrixCalculations.multiplyVectorByX(d.dydt(MatrixCalculations.sumVectors(x, MatrixCalculations.multiplyVectorByX(k1,0.5)), th),h);
        double[] k3 = MatrixCalculations.multiplyVectorByX(d.dydt(MatrixCalculations.sumVectors(x, MatrixCalculations.multiplyVectorByX(k2, 0.5)), th),h);
        double[] k4 = MatrixCalculations.multiplyVectorByX(d.dydt(MatrixCalculations.sumVectors(x, k3), (t+h)),h);
        return MatrixCalculations.sumVectors(MatrixCalculations.sumVectors(MatrixCalculations.sumVectors(MatrixCalculations.sumVectors(x,MatrixCalculations.multiplyVectorByX(k1,1.0/6)), MatrixCalculations.multiplyVectorByX(k2,1.0/2)),MatrixCalculations.multiplyVectorByX(k3,1.0/3)), MatrixCalculations.multiplyVectorByX(k4,1.0/6));
    }

}