/*
 * JFrameMarbleMain.java
 *
 * Created on 19. heinkuuta 2004, 15:31
 */
package marbles;

import marbles.log.*;
import graphlib.*;

/**
 *
 * @author  millat
 */
public class JFrameMarbleMain extends javax.swing.JFrame {
  
  private MarbleCanvas canvas = null;
  private MarbleContainer marbles = null;
  private JLabelLog log = new JLabelLog(" ");
  
  /** Creates new form JFrameMarbleMain */
  public JFrameMarbleMain() {
    initComponents();
    marbles = new MarbleContainer(2, 0, 0.5f, 1);
    canvas = new MarbleCanvas(500, 500, marbles, log);
    marbles.setDisplay(canvas);
    this.getContentPane().add(canvas, java.awt.BorderLayout.CENTER);
    this.getContentPane().add(log, java.awt.BorderLayout.SOUTH);
    this.pack();
  }
  
  private void runAnimation() {
    try {
      marbles.runAnimation();
    } catch (MatrixException exp) {
      log.error(exp);
      exp.printStackTrace();
    }
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents() {//GEN-BEGIN:initComponents
    jPanelControl = new javax.swing.JPanel();
    jPanelMove = new javax.swing.JPanel();
    jButtonUp = new javax.swing.JButton();
    jButtonDown = new javax.swing.JButton();
    jButtonRight = new javax.swing.JButton();
    jButtonLeft = new javax.swing.JButton();
    jPanelZoom = new javax.swing.JPanel();
    jButtonZoomIn = new javax.swing.JButton();
    jButtonZoomOut = new javax.swing.JButton();
    jPanelOptions = new javax.swing.JPanel();
    jButtonStartAnimation = new javax.swing.JButton();
    jPanelMessage = new javax.swing.JPanel();

    addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(java.awt.event.WindowEvent evt) {
        exitForm(evt);
      }
    });

    jPanelControl.setLayout(new java.awt.GridLayout(1, 0));

    jPanelMove.setLayout(new java.awt.BorderLayout());

    jPanelMove.setBorder(new javax.swing.border.TitledBorder(null, "Move & Zoom", javax.swing.border.TitledBorder.CENTER, javax.swing.border.TitledBorder.DEFAULT_POSITION));
    jButtonUp.setText("/\\");
      jButtonUp.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(java.awt.event.ActionEvent evt) {
          jButtonUpActionPerformed(evt);
        }
      });

      jPanelMove.add(jButtonUp, java.awt.BorderLayout.NORTH);

      jButtonDown.setText("\\/");
      jButtonDown.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(java.awt.event.ActionEvent evt) {
          jButtonDownActionPerformed(evt);
        }
      });

      jPanelMove.add(jButtonDown, java.awt.BorderLayout.SOUTH);

      jButtonRight.setText(">");
      jButtonRight.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(java.awt.event.ActionEvent evt) {
          jButtonRightActionPerformed(evt);
        }
      });

      jPanelMove.add(jButtonRight, java.awt.BorderLayout.EAST);

      jButtonLeft.setText("<");
      jButtonLeft.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(java.awt.event.ActionEvent evt) {
          jButtonLeftActionPerformed(evt);
        }
      });

      jPanelMove.add(jButtonLeft, java.awt.BorderLayout.WEST);

      jPanelZoom.setLayout(new java.awt.GridLayout(1, 0));

      jButtonZoomIn.setText("+");
      jButtonZoomIn.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(java.awt.event.ActionEvent evt) {
          jButtonZoomInActionPerformed(evt);
        }
      });

      jPanelZoom.add(jButtonZoomIn);

      jButtonZoomOut.setText("-");
      jButtonZoomOut.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(java.awt.event.ActionEvent evt) {
          jButtonZoomOutActionPerformed(evt);
        }
      });

      jPanelZoom.add(jButtonZoomOut);

      jPanelMove.add(jPanelZoom, java.awt.BorderLayout.CENTER);

      jPanelControl.add(jPanelMove);

      jPanelOptions.setBorder(new javax.swing.border.TitledBorder(null, "Options", javax.swing.border.TitledBorder.CENTER, javax.swing.border.TitledBorder.DEFAULT_POSITION));
      jButtonStartAnimation.setText("Start animation");
      jButtonStartAnimation.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(java.awt.event.ActionEvent evt) {
          jButtonStartAnimationActionPerformed(evt);
        }
      });

      jPanelOptions.add(jButtonStartAnimation);

      jPanelControl.add(jPanelOptions);

      getContentPane().add(jPanelControl, java.awt.BorderLayout.NORTH);

      getContentPane().add(jPanelMessage, java.awt.BorderLayout.SOUTH);

      pack();
    }//GEN-END:initComponents
    
    private void jButtonStartAnimationActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonStartAnimationActionPerformed
      new Thread() {
        public void run() {
          log.info("Animation started");
          runAnimation();
          log.info("Animation finished");
        }
      }.start();
    }//GEN-LAST:event_jButtonStartAnimationActionPerformed
    
  private void jButtonZoomOutActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonZoomOutActionPerformed
    canvas.zoomOut();
  }//GEN-LAST:event_jButtonZoomOutActionPerformed
  
  private void jButtonZoomInActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonZoomInActionPerformed
    canvas.zoomIn();
  }//GEN-LAST:event_jButtonZoomInActionPerformed
  
  private void jButtonRightActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonRightActionPerformed
    canvas.cameraRight();
  }//GEN-LAST:event_jButtonRightActionPerformed
  
  private void jButtonLeftActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonLeftActionPerformed
    canvas.cameraLeft();
  }//GEN-LAST:event_jButtonLeftActionPerformed
  
  private void jButtonDownActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonDownActionPerformed
    canvas.cameraDown();
  }//GEN-LAST:event_jButtonDownActionPerformed
  
  private void jButtonUpActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonUpActionPerformed
    canvas.cameraUp();
  }//GEN-LAST:event_jButtonUpActionPerformed
  
  /** Exit the Application */
  private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
    System.exit(0);
  }//GEN-LAST:event_exitForm
  
  /**
   * @param args the command line arguments
   */
  public static void main(String args[]) {
    new JFrameMarbleMain().show();
  }
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton jButtonUp;
  private javax.swing.JPanel jPanelOptions;
  private javax.swing.JPanel jPanelControl;
  private javax.swing.JPanel jPanelMove;
  private javax.swing.JButton jButtonDown;
  private javax.swing.JButton jButtonLeft;
  private javax.swing.JPanel jPanelMessage;
  private javax.swing.JButton jButtonStartAnimation;
  private javax.swing.JPanel jPanelZoom;
  private javax.swing.JButton jButtonRight;
  private javax.swing.JButton jButtonZoomOut;
  private javax.swing.JButton jButtonZoomIn;
  // End of variables declaration//GEN-END:variables
    
}
